<template>
  <div>
    <q-btn
      v-bind="btnProps"
      @click="onClickNewPlan"
    >
      <translate>
        New plan
      </translate>
    </q-btn>
    <q-dialog
      v-model="showAlgorithmSelectorDialog"
      :full-width="!isDesktopPlatform"
    >
      <q-card style="min-width: min(500px, 80vw)">
        <q-card-section>
          <div class="q-mb-md">
            <translate>
              Select the type of recommendation you want to use
            </translate>:
          </div>
          <q-list>
            <q-item
              tag="label"
              v-for="algo in storeFertilizationAlgorithms"
              :key="'algo-'+algo.id"
            >
              <q-item-section avatar>
                <q-radio
                  v-model="selectedAlgorithm"
                  :val="algo"
                  color="primary"
                />
              </q-item-section>
              <q-item-section>
                <q-item-label class="">
                  {{ algo.description }}
                </q-item-label>
                <q-item-label
                  caption
                >
                  {{ algo.name }} <span v-if="algo.provider">({{ algo.provider }})</span>
                </q-item-label>
              </q-item-section>
            </q-item>
          </q-list>
        </q-card-section>
        <q-card-section>
          <q-card-actions
            class="q-pa-none"
            align="right"
          >
            <q-btn
              class="q-mr-md"
              flat
              color="secondary"
              @click="onClickCancelAlgorithmSelection"
            >
              <translate>Cancel</translate>
            </q-btn>
            <q-btn
              color="primary"
              flat
              :disable="selectedAlgorithm == null"
              @click="onClickValidateAlgorithmSelection"
            >
              <translate>Ok</translate>
            </q-btn>
          </q-card-actions>
        </q-card-section>
      </q-card>
    </q-dialog>
  </div>
</template>

<script>
import { PlatformMixin } from 'src/mixins/PlatformMixin'
import FertilizationPlanMixin from 'src/pages/fieldbook/fertilization/mixins/FertilizationPlanMixin'

export default {
  name: 'NewFertilizationPlanButton',
  mixins: [PlatformMixin, FertilizationPlanMixin],
  props: {
    btnProps: {
      type: Object,
      required: false,
      default: () => {
        return {
          outline: true,
          color: 'primary'
        }
      }
    },
    newPlanOptions: {
      type: Object,
      required: false,
      default: null
    }
  },
  data () {
    return {
      showAlgorithmSelectorDialog: false,
      selectedAlgorithm: null
    }
  },
  computed: {
    storeFertilizationAlgorithms () {
      return this.$store.state.fastplatform?.config?.fertilizationAlgorithms
    }
  },
  methods: {
    async createNewPlan (algorithm) {
      const plot = this.newPlanOptions?.plot
      // reset the current fertilization plan store
      await this.$store.dispatch('fertilizationPlan/reset')
      // Set the selected algorithm in the store
      this.$store.commit('fertilizationPlan/setAlgorithm', algorithm)
      this.$store.commit('fertilizationPlan/setIsEdition', false)
      if (plot) {
        this.$store.commit('fertilizationPlan/setIsCreationFromPlot', true)
        const target = {
          ...plot,
          plot_plant_variety: plot.plot_plant_varieties?.[0]
        }
        this.$store.commit('fertilizationPlan/setTarget', target)
      }
      // open the algorithm pages
      this.$router.push({
        name: 'fertilizationPlanPlotSelection',
        query: plot ? { plot } : null
      })
    },
    onClickNewPlan () {
      if (this.storeFertilizationAlgorithms == null || this.storeFertilizationAlgorithms?.length === 0) {
        // no fertilization available for this region. Reload the config to load it.
        console.error('No fertilization algorithms available in the config')
        this.$q.notify({
          color: 'red',
          message: this.$gettext('No fertilization algorithm available.')
        })
      } else if (this.storeFertilizationAlgorithms.length > 1) {
        // ask the user which algorithm to use
        this.showAlgorithmSelectorDialog = true
      } else {
        this.createNewPlan(this.storeFertilizationAlgorithms[0])
      }
    },
    onClickCancelAlgorithmSelection () {
      this.showAlgorithmSelectorDialog = false
      this.selectedAlgorithm = null
    },
    onClickValidateAlgorithmSelection () {
      this.showAlgorithmSelectorDialog = false
      this.createNewPlan(this.selectedAlgorithm)
    }
  }
}
</script>
